description: |
  Base Pipeline for Data Release Production process, with only simple
  single-epoch calibration and characterizations.

  Never run this pipeline or any of its subsets directly; always use those in
  the 'pipelines' directory (or create a custom one) instead.

tasks:
  isr: lsst.ip.isr.IsrTask
  characterizeImage:
    class: lsst.pipe.tasks.characterizeImage.CharacterizeImageTask
    config:
      - python: |
          import lsst.meas.extensions.piff.piffPsfDeterminer
          config.measurePsf.psfDeterminer = "piff"
  calibrate: lsst.pipe.tasks.calibrate.CalibrateTask
  writeSourceTable: lsst.pipe.tasks.postprocess.WriteSourceTableTask
  transformSourceTable: lsst.pipe.tasks.postprocess.TransformSourceTableTask
  consolidateSourceTable: lsst.pipe.tasks.postprocess.ConsolidateSourceTableTask
  consolidateVisitSummary: lsst.pipe.tasks.postprocess.ConsolidateVisitSummaryTask
  isolatedStarAssociation: lsst.pipe.tasks.isolatedStarAssociation.IsolatedStarAssociationTask
  finalizeCharacterization: lsst.pipe.tasks.finalizeCharacterization.FinalizeCharacterizationTask
  makeCcdVisitTable: lsst.pipe.tasks.postprocess.MakeCcdVisitTableTask
  makeVisitTable: lsst.pipe.tasks.postprocess.MakeVisitTableTask
  makeWarp:
    class: lsst.pipe.tasks.makeWarp.MakeWarpTask
    config:
      makePsfMatched: true
  assembleCoadd:
    class: lsst.pipe.tasks.assembleCoadd.CompareWarpAssembleCoaddTask
    config:
      doInputMap: true
  healSparsePropertyMaps: lsst.pipe.tasks.healSparseMapping.HealSparsePropertyMapTask
  consolidateHealSparsePropertyMaps: lsst.pipe.tasks.healSparseMapping.ConsolidateHealSparsePropertyMapTask
  detection: lsst.pipe.tasks.multiBand.DetectCoaddSourcesTask
  mergeDetections: lsst.pipe.tasks.mergeDetections.MergeDetectionsTask
  deblend: lsst.pipe.tasks.deblendCoaddSourcesPipeline.DeblendCoaddSourcesMultiTask
  measure: lsst.pipe.tasks.multiBand.MeasureMergedCoaddSourcesTask
  mergeMeasurements: lsst.pipe.tasks.mergeMeasurements.MergeMeasurementsTask
  writeObjectTable: lsst.pipe.tasks.postprocess.WriteObjectTableTask
  transformObjectTable: lsst.pipe.tasks.postprocess.TransformObjectCatalogTask
  consolidateObjectTable: lsst.pipe.tasks.postprocess.ConsolidateObjectTableTask
  forcedPhotCcd: lsst.meas.base.forcedPhotCcd.ForcedPhotCcdTask
  forcedPhotCoadd: lsst.meas.base.forcedPhotCoadd.ForcedPhotCoaddTask
  selectGoodSeeingVisits:
    class: lsst.pipe.tasks.selectImages.BestSeeingQuantileSelectVisitsTask
    config:
      connections.goodVisits: goodSeeingVisits
  templateGen:
    class: lsst.pipe.tasks.assembleCoadd.CompareWarpAssembleCoaddTask
    config:
      doSelectVisits: true
      assembleStaticSkyModel.doSelectVisits: true
      connections.selectedVisits: goodSeeingVisits
      connections.outputCoaddName: goodSeeing
      # Setting template 'outputCoaddName' to goodSeeing is not sufficient to
      # convince contract checker that coaddExposure == goodSeeingCoadd
      connections.coaddExposure: goodSeeingCoadd
  getTemplate:
    class: lsst.ip.diffim.getTemplate.GetTemplateTask
    config:
      connections.coaddName: goodSeeing
      connections.coaddExposures: goodSeeingCoadd
      connections.template: goodSeeingDiff_templateExp
  subtractImages:
    class: lsst.ip.diffim.subtractImages.AlardLuptonSubtractTask
    config:
      connections.coaddName: goodSeeing
      connections.template: goodSeeingDiff_templateExp
      connections.difference: goodSeeingDiff_differenceTempExp
      connections.matchedTemplate: goodSeeingDiff_matchedExp
  detectAndMeasureDiaSources:
    class: lsst.ip.diffim.detectAndMeasure.DetectAndMeasureTask
    config:
      connections.coaddName: goodSeeing
      connections.matchedTemplate: goodSeeingDiff_matchedExp
      connections.difference: goodSeeingDiff_differenceTempExp
      connections.subtractedMeasuredExposure: goodSeeingDiff_differenceExp
  transformDiaSourceCat:
    class: lsst.ap.association.TransformDiaSourceCatalogTask
    config:
      doPackFlags: false
      connections.coaddName: goodSeeing
      connections.diaSourceSchema: goodSeeingDiff_diaSrc_schema
      connections.diaSourceCat: goodSeeingDiff_diaSrc
      connections.diffIm: goodSeeingDiff_differenceExp
      connections.diaSourceTable: goodSeeingDiff_diaSrcTable
  consolidateDiaSourceTable:
    class: lsst.pipe.tasks.postprocess.ConsolidateSourceTableTask
    config:
      connections.inputCatalogs: goodSeeingDiff_diaSrcTable
      connections.outputCatalog: diaSourceTable
  drpAssociation:
    class: lsst.pipe.tasks.drpAssociationPipe.DrpAssociationPipeTask
    config:
      connections.coaddName: goodSeeing
      connections.diaSourceTables: goodSeeingDiff_diaSrcTable
      connections.assocDiaSourceTable: goodSeeingDiff_assocDiaSrcTable
      connections.diaObjectTable: goodSeeingDiff_diaObjTable
  drpDiaCalculation:
    class: lsst.pipe.tasks.drpDiaCalculationPipe.DrpDiaCalculationPipeTask
    config:
      connections.coaddName: goodSeeing
      connections.assocDiaSourceTable: goodSeeingDiff_assocDiaSrcTable
      connections.diaObjectTable: goodSeeingDiff_diaObjTable
      connections.fullDiaObjectTable: goodSeeingDiff_fullDiaObjTable
  consolidateAssocDiaSourceTable:
    class: lsst.pipe.tasks.postprocess.ConsolidateTractTask
    config:
      connections.inputCatalogs: goodSeeingDiff_assocDiaSrcTable
      connections.outputCatalog: diaSourceTable_tract
  consolidateFullDiaObjectTable:
    class: lsst.pipe.tasks.postprocess.ConsolidateTractTask
    config:
      connections.inputCatalogs: goodSeeingDiff_fullDiaObjTable
      connections.outputCatalog: diaObjectTable_tract
  forcedPhotDiffim:
    class: lsst.meas.base.ForcedPhotCcdTask
    config:
      connections.measCat: forced_diff
      connections.outputSchema: forced_diff_schema
      connections.exposure: goodSeeingDiff_differenceExp
  writeForcedSourceTable: lsst.pipe.tasks.postprocess.WriteForcedSourceTableTask
  transformForcedSourceTable: lsst.pipe.tasks.postprocess.TransformForcedSourceTableTask
  consolidateForcedSourceTable:
    class: lsst.pipe.tasks.postprocess.ConsolidateTractTask
    config:
      connections.inputCatalogs: forcedSourceTable
      connections.outputCatalog: forcedSourceTable_tract
  forcedPhotCcdOnDiaObjects:
    class: lsst.meas.base.ForcedPhotCcdFromDataFrameTask
  forcedPhotDiffOnDiaObjects:
    class: lsst.meas.base.ForcedPhotCcdFromDataFrameTask
    config:
      connections.measCat: forced_diff_diaObject
      connections.outputSchema: forced_diff_diaObject_schema
      connections.exposure: goodSeeingDiff_differenceExp
  writeForcedSourceOnDiaObjectTable:
    class: lsst.pipe.tasks.postprocess.WriteForcedSourceTableTask
    config:
      key: diaObjectId
      connections.inputCatalogDiff: forced_diff_diaObject
      connections.inputCatalog: forced_src_diaObject
      connections.outputCatalog: mergedForcedSourceOnDiaObject
  transformForcedSourceOnDiaObjectTable:
    class: lsst.pipe.tasks.postprocess.TransformForcedSourceTableTask
    config:
      referenceColumns: []
      keyRef: diaObjectId
      key: forcedSourceOnDiaObjectId
      connections.inputCatalogs: mergedForcedSourceOnDiaObject
      connections.outputCatalog: forcedSourceOnDiaObjectTable
      connections.referenceCatalog: goodSeeingDiff_fullDiaObjTable
  consolidateForcedSourceOnDiaObjectTable:
    class: lsst.pipe.tasks.postprocess.ConsolidateTractTask
    config:
      connections.inputCatalogs: forcedSourceOnDiaObjectTable
      connections.outputCatalog: forcedSourceOnDiaObjectTable_tract
subsets:
  # This pipeline file only defines subsets that have a consistent or
  # near-consistent definition as a set of tasks, for use by downstream
  # pipelines as way to include or exclude those tasks.  It does not (and
  # should not) contain "step" subsets aimed at splitting up a processing
  # campaign.
  processCcd:
    subset:
      - isr
      - characterizeImage
      - calibrate
    description: >
      Set of tasks to run when doing single frame processing, without any
      conversions to Parquet/DataFrames or visit-level summaries.
  sourceTable:
    subset:
      - writeSourceTable
      - transformSourceTable
      - consolidateSourceTable
    description: >
      Set of tasks to generate parquet Source Tables from output of processCcd
      subset.
  coaddition:
    subset:
      - makeWarp
      - assembleCoadd
      - healSparsePropertyMaps
    description: >
      A set of tasks to run when coadding images.
  multiband:
    subset:
      - detection
      - mergeDetections
      - deblend
      - measure
      - mergeMeasurements
      - forcedPhotCoadd
    description: >
      A set of tasks to run when making measurements on coadds.
  objectTable:
    subset:
      - writeObjectTable
      - transformObjectTable
      - consolidateObjectTable
    description: >
      A set of tasks to transform multiband outputs into a parquet object
      table.
  forced:
    subset:
      - forcedPhotCcd
      - forcedPhotCoadd
    description: >
      A set of tasks to run when doing forced measurements.
  diffimDRP:
    subset:
      - selectGoodSeeingVisits
      - templateGen
      - getTemplate
      - subtractImages
      - detectAndMeasureDiaSources
      - transformDiaSourceCat
      - consolidateDiaSourceTable
      - drpAssociation
      - drpDiaCalculation
      - forcedPhotDiffim
      - forcedPhotCcdOnDiaObjects
      - forcedPhotDiffOnDiaObjects
    description: >
      Subset for running image differencing branch of the DRP pipeline

contracts:
  - selectGoodSeeingVisits.connections.goodVisits == templateGen.connections.selectedVisits
  - templateGen.connections.coaddExposure == getTemplate.connections.coaddExposures
  - getTemplate.connections.template == subtractImages.connections.template
  - subtractImages.connections.matchedTemplate == detectAndMeasureDiaSources.connections.matchedTemplate
  - subtractImages.connections.difference == detectAndMeasureDiaSources.connections.difference
  - detectAndMeasureDiaSources.connections.subtractedMeasuredExposure == transformDiaSourceCat.connections.diffIm
  - detectAndMeasureDiaSources.connections.subtractedMeasuredExposure == forcedPhotDiffim.connections.exposure
  - transformDiaSourceCat.connections.diaSourceTable == consolidateDiaSourceTable.connections.inputCatalogs
  - transformDiaSourceCat.connections.diaSourceTable == drpAssociation.connections.diaSourceTables
  - drpAssociation.connections.assocDiaSourceTable == drpDiaCalculation.connections.assocDiaSourceTable
  - drpAssociation.connections.diaObjectTable == drpDiaCalculation.connections.diaObjectTable
  - forcedPhotDiffim.connections.refCat == forcedPhotCcd.connections.refCat
  - consolidateHealSparsePropertyMaps.property_maps == healSparsePropertyMaps.property_maps
  - "'calib_psf_candidate' not in measure.propagateFlags.source_flags if makeWarp.doApplyFinalizedPsf else True"
  - "'calib_psf_used' not in measure.propagateFlags.source_flags if makeWarp.doApplyFinalizedPsf else True"
  - "'calib_psf_reserved' not in measure.propagateFlags.source_flags if makeWarp.doApplyFinalizedPsf else True"
